<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: Installing and Executing MeLOn</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('install.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div><div class="header">
  <div class="headertitle"><div class="title">Installing and Executing MeLOn</div></div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>When you want to use machine-learning models in optimization, we recommend to you to download and install the MAiNGO solver. We provide MeLOn as a submodule within MAiNGO. This way, the machine-learning models can be directly used within optimization problems. If you want to see a few examples for the usage of machine learning models in MAiNGO, please see the example problems here: <a href="https://git.rwth-aachen.de/avt.svt/public/maingo/-/tree/master/examples">https://git.rwth-aachen.de/avt.svt/public/maingo/-/tree/master/examples</a> As described below, you can also download MeLOn as a standalone library for machine learning models in C++. When compiling MeLOn as a standalone tool, we automatically set up a few tests.</p>
<h1><a class="anchor" id="get_melon"></a>
Obtaining MeLOn</h1>
<p>In order to obtain MeLOn, we strongly recommend using Git (Git Bash on Windows). It is possible to download MeLOn as a .zip folder, but we strongly recommend to use Git and follow the given instructions (in particular because we use submodules for dependencies, which need to be downloaded separately when not using Git). First you need to clone the MeLOn repository. This is done by </p><div class="fragment"><div class="line">git clone https://git.rwth-aachen.de/avt.svt/public/melon.git &lt;directory&gt;</div>
</div><!-- fragment --><p> where &lt;directory&gt; is the name of the directory where you can find all MeLOn files after cloning (default name is melon). After the cloning is done, simply navigate to the directory. In the cloned MeLOn directory execute </p><div class="fragment"><div class="line">git submodule init</div>
</div><!-- fragment --><p> If nothing happens, you are <b>not</b> in the cloned MeLOn directory and have to navigate to there first. For Windows users, we recommend the usage of HTTPS protocols for Git and SSH protocols for Linux and Mac OS users to avoid multiple username and password inputs. For more info on SSH keys, see the Git documentation on SSH authentication which can be found under <b>Help -&gt; SSH authentication</b> in your GitLab. If you are having HTTPS authentication problems on Windows, please make sure that your cedential manager has the correct settings. The Windows credential manager can be found at <b>Control Panel -&gt; User Accounts -&gt; Manage your credentials</b>.</p>
<p>In order to proceed and update all submodules of MeLOn, execute </p><div class="fragment"><div class="line">git submodule update -j 1</div>
</div><!-- fragment --><p> in the MeLOn directory. You can determine whether the above worked properly by checking if each dependency folder in the <code>dep/</code> folder is non-empty. In the case that the above <b><em>DID</em> <em>NOT</b></em> work properly, execute the following in the MeLOn directory </p><div class="fragment"><div class="line">git submodule foreach git checkout master</div>
<div class="line">git submodule foreach git pull</div>
</div><!-- fragment --><p> A note for user more familiar with Git: the <code>git submodule update</code> is exectued without the <code>&ndash;recursive</code> option. This avoids instantiating any indirect dependencies; in the repository design of MeLOn, all dependencies (including indirect ones) are present in the <code>dep</code> folder. It is also executed using only one process <code>-j 1</code> to avoid input failures.</p>
<h2><a class="anchor" id="update_melon"></a>
Updating MeLOn</h2>
<p>If you want to update to the latest MeLOn version, use the following git commands </p><div class="fragment"><div class="line">git pull</div>
<div class="line">git submodule update</div>
</div><!-- fragment --><p> If you changed any of the source files in MeLOn or any dependency found in the <code>dep/</code> folder, you should restore the original state of MeLOn by first saving a copy of the files you changed (or using <code>git stash</code>) and then executing </p><div class="fragment"><div class="line">git checkout .</div>
</div><!-- fragment --><p> in the MeLOn repository and/or in any dependency repository you edited. Then, update the MeLOn repository with the <code>pull</code> and <code>submodule update</code> commands. Finally, you can replace the files of interest by your saved copies (or retrieve them via <code>git stash pop</code>).</p>
<h1><a class="anchor" id="req_software"></a>
Required Software</h1>
<p>Building MeLOn requires the following non-standard programs that are not in the Git repository:</p><ul>
<li>CMake 3.8 or later</li>
<li>Visual Studio 2017 (Windows only)</li>
<li>A Fortran Compiler (Linux and Mac OS)</li>
</ul>
<p>All other third-party software that MeLOn depends on comes with the MeLOn Git. Unless you feel the need to modify the folder structure or switch to other versions (in which case we would appreciate you contacting the MeLOn team as well), there is nothing you need to do.</p>
<h1><a class="anchor" id="cmake"></a>
Generating and Compiling the Project</h1>
<p>MeLOn uses CMake for setting up the required Visual Studio project (for Windows) or Makefile (for Linux or Mac OS).</p>
<p>A note for users seeking to include MeLOn in their own code: MeLOn uses modern target-oriented cmake commands. The <code>CMakeLists.txt</code> in the root directory is the sole entry point both for building MeLOn as a standalone solver or including it into your project. However, when including it into your code you will need to add all dependencies (i.e., all folders within the <code>dep</code> folder in the MeLOn repository) in your own CMakeLists.txt using <code>add_subdirectory</code>. Please see also section embedded.</p>
<h2><a class="anchor" id="cmake_win"></a>
Windows</h2>
<p>On Windows, only Microsoft Visual C++ 2017 is supported. We supply pre-compiled versions for all Fortran libraries, so no Fortran compiler (or runtime) should be needed. To generate the Visual Studio project and compile MeLOn, you need to complete the following steps:</p>
<ol type="1">
<li>Start CMake and navigate or type the path to your MeLOn directory (this is the one where the Readme.md is) and select your build directory.  <style>div.image img[src="CMakeHead.PNG"]{width:15cm;align:left}</style>  <div class="image">
<img src="CMakeHead.PNG" alt="" width="15cm"/>
</div>
</li>
<li>Use the <em>Configure</em> button to choose Visual Studio 15 2017 Win64 as generator (or Visual Studio 15 2017 as generator and x64 as optional platform for generator in the newer versions of CMake). Make sure that you use default native compilers. Press <em>Finish</em> and wait for the configuration to complete. If at the end you get a message saying <code>Configuring done</code>, everything worked fine.  <style>div.image img[src="CMakeGenerator.PNG"]{width:25cm;align:left}</style>  <div class="image">
<img src="CMakeGenerator.PNG" alt="" width="25cm"/>
</div>
</li>
<li>If desired, you can now change the CMake variables. (not applicable here)</li>
<li>Press the <em>Generate</em> button. You should get a message saying <code>Generating done</code>.</li>
<li>Press the <em>Open</em> <em>Project</em> button (or open the <code>MeLOn.sln</code> file (with Visual Studio 15 2017) that was created by CMake in the build directory you specified). Make sure to set the build type to <em>Release</em>, since this will result in MeLOn being significantly faster.  <style>div.image img[src="VS_Release.PNG"]{width:6cm;align:left}</style>  <div class="image">
<img src="VS_Release.PNG" alt="" width="6cm"/>
</div>
</li>
<li>Compile MeLOn by clicking <code>Build-&gt;Build solution</code>. This will create the executables.</li>
</ol>
<h2><a class="anchor" id="cmake_linux_os"></a>
Linux and Mac OS</h2>
<p>We recommend to create a build folder in the MeLOn directory first and then navigate to it (you can create the build folder anywhere else on you machine). </p><div class="fragment"><div class="line">mkdir build</div>
<div class="line">cd build</div>
</div><!-- fragment --><p> Then simply execute cmake using the CMakeLists.txt from the MeLOn directory by </p><div class="fragment"><div class="line">cmake ..</div>
</div><!-- fragment --><p> You can change the CMake variables explained above by adding <code>-D&lt;name_of_cmake_variable&gt;=&lt;value&gt;</code> after the <code>cmake</code> command. To compile the code execute </p><div class="fragment"><div class="line">make</div>
</div><!-- fragment --><p> You can add the option <code>-j n</code> to compile using n cores of your machine, e.g., execute <code>make -j 4</code> to compile using 4 cores. </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="index.html">MeLOn - Machine Learning models for Optimization</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
